config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.dovecot.new

for file in etc/dovecot/*.conf.new etc/dovecot/*.ext.new etc/dovecot/conf.d/*.conf.new etc/dovecot/conf.d/*.ext.new ; do
  config $file
done

if [ -r etc/pam.d/dovecot.new ]; then
  config etc/pam.d/dovecot.new
fi

# Make sure that the dovecot user/group (UID 94, GID 94), and the
# postdrop user/group (UID 65, GID 95) exist on this system:
if ! grep -q "^dovecot:" etc/passwd ; then
  echo "dovecot:x:94:94:User for Dovecot processes:/dev/null:/bin/false" >> etc/passwd
fi
if ! grep -q "^dovenull:" etc/passwd ; then
  echo "dovenull:x:95:95:User for Dovecot login processing:/dev/null:/bin/false" >> etc/passwd
fi
if ! grep -q "^dovecot:" etc/group ; then
  echo "dovecot:x:94:" >> etc/group
fi
if ! grep -q "^dovenull:" etc/group ; then
  echo "dovenull:x:95:" >> etc/group
fi

( cd usr/bin ; rm -rf dsync )
( cd usr/bin ; ln -sf doveadm dsync )
( cd usr/lib/dovecot ; rm -rf libdovecot-compression.so )
( cd usr/lib/dovecot ; ln -sf libdovecot-compression.so.0.0.0 libdovecot-compression.so )
( cd usr/lib/dovecot ; rm -rf libdovecot-compression.so.0 )
( cd usr/lib/dovecot ; ln -sf libdovecot-compression.so.0.0.0 libdovecot-compression.so.0 )
( cd usr/lib/dovecot ; rm -rf libdovecot-dsync.so )
( cd usr/lib/dovecot ; ln -sf libdovecot-dsync.so.0.0.0 libdovecot-dsync.so )
( cd usr/lib/dovecot ; rm -rf libdovecot-dsync.so.0 )
( cd usr/lib/dovecot ; ln -sf libdovecot-dsync.so.0.0.0 libdovecot-dsync.so.0 )
( cd usr/lib/dovecot ; rm -rf libdovecot-fts.so )
( cd usr/lib/dovecot ; ln -sf libdovecot-fts.so.0.0.0 libdovecot-fts.so )
( cd usr/lib/dovecot ; rm -rf libdovecot-fts.so.0 )
( cd usr/lib/dovecot ; ln -sf libdovecot-fts.so.0.0.0 libdovecot-fts.so.0 )
( cd usr/lib/dovecot ; rm -rf libdovecot-lda.so )
( cd usr/lib/dovecot ; ln -sf libdovecot-lda.so.0.0.0 libdovecot-lda.so )
( cd usr/lib/dovecot ; rm -rf libdovecot-lda.so.0 )
( cd usr/lib/dovecot ; ln -sf libdovecot-lda.so.0.0.0 libdovecot-lda.so.0 )
( cd usr/lib/dovecot ; rm -rf libdovecot-ldap.so )
( cd usr/lib/dovecot ; ln -sf libdovecot-ldap.so.0.0.0 libdovecot-ldap.so )
( cd usr/lib/dovecot ; rm -rf libdovecot-ldap.so.0 )
( cd usr/lib/dovecot ; ln -sf libdovecot-ldap.so.0.0.0 libdovecot-ldap.so.0 )
( cd usr/lib/dovecot ; rm -rf libdovecot-login.so )
( cd usr/lib/dovecot ; ln -sf libdovecot-login.so.0.0.0 libdovecot-login.so )
( cd usr/lib/dovecot ; rm -rf libdovecot-login.so.0 )
( cd usr/lib/dovecot ; ln -sf libdovecot-login.so.0.0.0 libdovecot-login.so.0 )
( cd usr/lib/dovecot ; rm -rf libdovecot-lua.so )
( cd usr/lib/dovecot ; ln -sf libdovecot-lua.so.0.0.0 libdovecot-lua.so )
( cd usr/lib/dovecot ; rm -rf libdovecot-lua.so.0 )
( cd usr/lib/dovecot ; ln -sf libdovecot-lua.so.0.0.0 libdovecot-lua.so.0 )
( cd usr/lib/dovecot ; rm -rf libdovecot-sql.so )
( cd usr/lib/dovecot ; ln -sf libdovecot-sql.so.0.0.0 libdovecot-sql.so )
( cd usr/lib/dovecot ; rm -rf libdovecot-sql.so.0 )
( cd usr/lib/dovecot ; ln -sf libdovecot-sql.so.0.0.0 libdovecot-sql.so.0 )
( cd usr/lib/dovecot ; rm -rf libdovecot-storage-lua.so )
( cd usr/lib/dovecot ; ln -sf libdovecot-storage-lua.so.0.0.0 libdovecot-storage-lua.so )
( cd usr/lib/dovecot ; rm -rf libdovecot-storage-lua.so.0 )
( cd usr/lib/dovecot ; ln -sf libdovecot-storage-lua.so.0.0.0 libdovecot-storage-lua.so.0 )
( cd usr/lib/dovecot ; rm -rf libdovecot-storage.so )
( cd usr/lib/dovecot ; ln -sf libdovecot-storage.so.0.0.0 libdovecot-storage.so )
( cd usr/lib/dovecot ; rm -rf libdovecot-storage.so.0 )
( cd usr/lib/dovecot ; ln -sf libdovecot-storage.so.0.0.0 libdovecot-storage.so.0 )
( cd usr/lib/dovecot ; rm -rf libdovecot.so )
( cd usr/lib/dovecot ; ln -sf libdovecot.so.0.0.0 libdovecot.so )
( cd usr/lib/dovecot ; rm -rf libdovecot.so.0 )
( cd usr/lib/dovecot ; ln -sf libdovecot.so.0.0.0 libdovecot.so.0 )
( cd usr/libexec/dovecot ; rm -rf deliver )
( cd usr/libexec/dovecot ; ln -sf dovecot-lda deliver )
